#------------------------------------------------------------------------------
# Module      : T e x t . p m
#------------------------------------------------------------------------------
# Autor       : Christian Dhl
# Created     : 18. Januar 2005
# last change : 22. Januar 2005
# Task        : Texts of TODO-List and History of GED
#------------------------------------------------------------------------------

package Graph::GED::Text;

use strict;
use warnings;


#------------------------------------------------------------------------------
# Derive from Exporter:
#------------------------------------------------------------------------------
use base qw/Exporter/;
our @EXPORT_OK = qw/$Todotext $Historytext/;


#------------------------------------------------------------------------------
# todo text:
#------------------------------------------------------------------------------
our $Todotext = <<'TODOTEXT';
- Neue Dateien mit englischen Namen und Kommentaren, alte irgendwann umstellen.

- HTML-Hilfe mit Screenshots erstellen, die man ber Hilfe ... starten kann.
  oder mit Texten und Bildern im Textwidget (dafr ($top, $text) zurckliefern
  und ROText benutzen).

- Automatische Umordnungen der Ecken ...

- Automatisches Vermeiden von Kantenberschneidungen, wenn das geht ...
  Linienberschneidungen diagnostizieren...
  Algorithmus: Wann schneiden sich zwei Strecken in der Ebene?

- Iconleiste : Drucken... Funktionalitt wie?
  Dazu schrieb ptk: unter Unix koennte man den Umweg ueber einen
  Postscript-Viewer gehen. D.h. Postscript in eine temporaere Datei schreiben
  und dann kghostview, ggv oder ghostview aufrufen, je nachdem, was vorhanden
  ist. Dort kann man meist den Drucker auswaehlen und hat gleich eine
  Druckansicht. Oder man verwendet kprinter nur fuer die Druckerauswahl (keine
  Ahnung, was man hier unter GNOME verwenden wuerde). Unter Windows ist die
  Sache schwieriger. Man koennte versuchen tkWinPrint von Tcl/Tk nach Perl/Tk
  zu portieren. Man koennte aus dem Graphen ein PDF erzeugen und dann mit
  PDF::Create oder aehnlichem ein PDF erzeugen und dann Acrobat Reader
  aufrufen.

- Linienzge automatisch verfeinern (mit Skala) (Einfgen von Zwischenecken
  vom Grad 2 an entsprechenden Punkten ["entsprechend" => Spline...]).

- Flchen fllen...
  Idee: Wenn Linien dazukommen und dadurch Flchen aufteilen, wird ein neuer
  Farbwert erzeugt.
  berlegen, ob das nur bei ebenen Graphen gemacht wird.

- Aufspaltung des Programms in verschiedene Richtungen (ev. per Auswahl ber
  Men oder per internem Define?)

- Speicher- und lademglichkeit fr Animationen fehlen noch.
  Dazu sollte man die Einzelgraphen in arrays "printen" und dann erst
  ausgeben.

- Anbindung an Algorithmen ermglichen, so dass diese visualisiert werden
  knnen.
  Graph::GED::Algorithm::Coloring.pm
  Graph::GED::Algorithm::Serach.pm

- Funktionsbersicht (Auflistung der Funktionen in ihrer Reihenfolge und kurze
  Erklrung).
  Hier ev. Prototypliste mit Kommentaren ergnzen.

- Modus, in dem man Ecken anfgt, die automatisch mit einer (normalen?) Kante
  mit der zuletzt eingefgten verbunden werden.
  [Ev. auch in allen Kantenausprgungen.]

- Mehrfachkantenproblem lsen. Am besten ist es so, dass der Editor erkennt,
  dass da eine zustzliche Kante eingezeichnet wird. Er muss die Kanten dann im
  leichten  Bogen darstellen.
  Bei ungerader Anzahl ist die erste gerade, die zweite rechts davon leicht
  gewlbt, die dritte links, die vierte wieder rechts...
  Bei gerader Anzahl genauso ohne die mittlere Kante und dafr mit etwas
  schwcherer Startwlbung.

- Tk:ProgressBar (in Statuszeile oder extra darber oder in extra Fenster)
  whrend Berechnungen laufen (etwa Liniengraphberechnung).

- Unterstzung mehrerer Graphen (n Stck) nebeneinander, Unterscheidung
  vielleicht durch verschiedene Ecken- und Kantenfarben, bei allen Funktionen
  die Graphen zur Auswahl bringen in Frame mit Canvas-Items.
  Werden zwei Graphen durch eine Kante verbunden, muss daraus einer werden.
  Listbox zum Whlen des Graphen.
  Farben mssen natrlich auch fr alle Graphen whlbar sein.

- Konfigurationsseiten mit Tk::NoteBook (S. 576 Mastering Perl/Tk).

- Iconhintergrnde angleichen (das Wei ist etwas unterschiedlich [oder wirkt
  so wegen der blauen Linien?]).

- Es sollte mglich sein, mehrere Ecken irgendwie mit der Maus zu markieren
  (mit einer Art Lassofunktion) und dann gemeinsam zu behandeln (Lschen und
  insb. Verschieben). Ev. erstmal mit Rechteck oder shift und Anklicken
  realisieren.

- Funktion, die alle Ecken im Raster einrasten lsst, mit Suche nach anderen
  Positionen in der Nhe, bei Zuweisung auf den gleichen Gitterpunkt.

- Pinselfrbetool: Es wird ein Palettenbild rechts zwischen den Buttons ange-
  zeigt, daraus kann der User mit Pinselchen eine Farbe whlen und damit auf
  die Zeichenflche klicken. Mit meint_ecke und dann meint_kante wird getestet,
  welche Ecke oder Kante gemeint war und wenn es eindeutig ist, das entspre-
  chende Element mit dieser Farbe eingefrbt.

- POD erweitern.

- Plttbare Graphen erkennen, Funktion, die plttbare Graphen ohne
  Kantenberschneidungen darstellt.
   - Gibt es dazu schon was?
   - Land mit grter Eckenzahl nach auen?
   - Ecken mit hchstem Grad nach innen?

- Fr ebene Graphen: sonst deaktivierte Meneintrge sind dann anwhlbar:
      * Aus dem Graphen den Graphen erstellen, der entsteht, wenn man in jedes
        Land eine neue Ecke setzt und zwei dieser Ecken mit einer Kante
        verbindet, wenn die Lnder aneinander stoen.
      * Triangulierung: in alle Lnder Kanten einfgen, bis alle Lnder
        dreieckig sind. Optional mit oder ohne uerem Land. (Ev. muss bei mit
        eine Eckenumordnung erfolgen, damit der Graph eben bleibt, aber ev.
        auch schon ohne.:

         2 *-----------* 1
             \         |
               \       |
              3  *     |
                 |     |
                 |     |
                 |     |
                 |     |
                 |     |
                 |     |
                 |     |
              4  *-----* 5

        Fgt man eine Kante 2-4 oder 2-5 ein, so liegt die direkte Verbindung
        auerhalb des Landes.)

- Funktion, die den Graphen bei Proportionserhaltung vergrert und zentriert
  so dass er wieder voll zu sehen ist.

- load as new selecton

- Irgendwann so umstellen, dass die Kantenklassen keine Indizes, sondern
  Eckenobjekte enthalten?
  Die Ecken wren dann in der Eckenmenge und auch direkt an den Kanten.
  Da die Objekte ja Referenzen sind, msste es gehen ohne redundante Infor-
  mationen vorzuhalten. Wird eine Ecke mit allen anstoenden Kanten entfernt,
  mste das Eckenobjekt von der Garbage Collection im Speicher freigegeben
  werden.
  Am besten setzt man dabei die Kantenenden auf undef, damit Kanten und Ecke
  in einem Schritt entfernt werden knnen. (Ich wei nicht, ob die GC schlau
  genug wre zu erkennen, dass die Referenzierung von einem unreferenzierten
  Objekt aus stattfindet [Kanten verweisen noch auf Ecke].)

  -> $self->ecke($kante->a())->x()
  daraus wrde dann
  -> $self->$kante->a()->x()

  Aber der Nachteil ist, man kann den Kanten nicht mehr ansehen, an welche
  Eckennummern sie stoen.
  Erstmal so lassen. Die nderung wre nicht kompliziert, man msst das
  Eckenarray aus Graph2D nach Graph verschieben und die Funktionalitt
  anpassen.
  Fr obigen unschnen Aufruf fge ich Funktionen in Graph2D ein:
  x_von_a, y_von_a, x_von_e, y_von_e, die man mit einer Kante aufruft
  und die einem die entsprechende Koordinate zurckgeben.
  Dann ist das Innenleben wieder ein Stck weiter gekapselt.

- Funktionalitt Kantenauswahl lschen: eine wie auch immer geartete Auswahl:
  etwa alle Ecken leuchten in paarweisen Farben auf wenn es uneindeutig ist
  und man muss dann auf eine der Ecken klicken.

- make install oder entsprechende Funktionalitt anbieten.

- Optional LaTeX-Export mit Dokumentrahmen umgeben. Vielleicht den jetzigen
  Menpunkt durch untermen ersetzen, wo man beide Varianten zur Auswahl hat.
  Oder ein Zwischendialog, wo man diese Wahl ber Checkbuttons o.. treffen
  kann.

- LaTeX-Export um neue Elemente wie Beschriftungen, Werte und Kantenstile
  ergnzen.
  Die Funktion gehrt in Graph2D.

- Ev. blaue Hilfstexte rechtsbndig. (-anchor => 'w') Testen und entscheiden.

- Operationen wie Kanten einfgen oder Ecke bewegen abbrechbar machen.
  (ber Escape oder ber Klick auf anderen Button?)

- Ecken- und Kantenbeschreibungen und -gewichte: Farbe und normal / fett /
  kursiv / fett und kursiv auswhlbar.

- Aus %Konfig eigene Konfigurationsklasse Graph::GED::Config.pm machen?
  Wahrscheinlich ist das bertrieben.

- Eventuell kann man jetzt auf das Anzeigefeld mit der gewhlten Funktionalitt
  verzichten.

- In Bildern eckenartige Gebilde erkennen und "echte" Ecken ber diese legen.
  Eventuell auch fr Kanten.

- Gitterklasse, Verwaltung ber Graph2d. Wenn dies steht, raste_ein in
  Gitterklasse und nach verkleinern / vergrern ins Gitter einrasten, falls
  die Option aktiv ist.

- FHist: $FindBin:RealBin verwenden!

- Changed muss fr die Animation irgendwie pro Graphen gehalten werden, also
  entweder in Graph2D oder in Animation, wobei ich Graph2D bevorzuge.

- Eventuell Graph::GED umstellen auf GED::Graph? Dann knnte man besser
  zwischen den Graphenklassen (in GED::Graph) und den GED-Klassen (in GED)
  unterscheiden. Allerdings wrde man dann eine weitere Grundklasse auf dem
  CPAN verursachen, wenn ich die Module irgendwann dor einstelle.

Renees Wunschliste:
~~~~~~~~~~~~~~~~~~~
- Export von Graphen in ein Bildformat wie png oder jpg.

Ishkas Wunschliste:
~~~~~~~~~~~~~~~~~~~
- Punkt einfgen, der mit allen Punkten verbunden ist
- Punkt verschieben und dabei alle mit diesem Punkt verbundene Punkte mitverschieben
- gleiches mit Lschen
- bei gerichteten Graphen: von einem Punkt aus alle erreichbaren einfrben
- gleiches mit lschen (ebenso: alle nicht-erreichbaren lschen)
- alternativ zu beiden vorhergehenden Vorschlgen: Punkten Flags geben, die
  man ber Auswahl ndern kann (ala: Alle mit dem als nchsten anzuklickenden
  Punkt verbundenen Punkte flag xyz um eins erhhen, ...) und ber diese Flags
  Punkte auswhlen und zB. lschen, verschieben und was auch immer

Bugreports:
~~~~~~~~~~~
- wenn debug auf 0 steht wird immer noch alles mgliche ausgegeben.
- Speichern und Export scheint unter Linux die Extensionen ohne Punkt dazwischen
  an die Namen anzuhngen. Unter Windows luft es richtig.
- Nichtverschwinden des Kontextmens unter Linux beheben.
- Probleme beim Vorbelegen der Namen fr das Wandeln in LaTeX bzw. PS unter
  Windows 98. (Unter Win2k ok)
- Probleme mit dem Dateipfad unter Windows 98. (Unter Win2k ok)
TODOTEXT














#------------------------------------------------------------------------------
# History text:
#------------------------------------------------------------------------------
our $Historytext = <<'HISTORYTEXT';
Version 0.0.1 - 31.01.2003 (6.882 Byte - 195 Zeilen - ged_2003_01_31.pl)
~~~~~~~~~~~~~
Aufbauend auf dem Beispiel "Ein Zeichenprogramm" auf Seite 213/214 im Buch
"Einfhrung in Perl / Tk" von Nancy Walsh entsteht das Grundgerst.

Man kann Kreise setzten (Ecken) und beliebige Striche ziehen.

Funktionen:
    tk_start
    bind_start
    zeichnen_anfang
    aendere_item
    zeichnen_ende


Version 0.0.2 - 03.02.2003 (25.370 Byte - 678 Zeilen - ged_2003_02_03.pl)
~~~~~~~~~~~~~
- Ideensammlung relativ am Anfang der Datei als Kommentare eingefgt.
- $Canvas eingefhrt.
- weitere globale Variablen: $N, $Radius, $Delta, @EckenX, @EckenY, @KantenA,
  @KantenE, @Kantenform, $M, $KantenA, $Kantenform, $Zx, $Zy.
- Clear-Button rechts oben eingefgt.
- Quit- und Refresh-Button eingefgt.
- ESC an Programmende und F5 an refresh gebunden.
- Zeichenanfangsecke ($KantenA) und Kantenform ($Kantenform) merken.
- Eckenkoordinaten beim Zeichnen in den Arrays ablegen und $N hochzhlen.
- Eckenlschen eingebaut.
- Kanten drfen nur noch in der Nhe von Ecken beginnen und enden und rasten
  dann auf diesen ein.

Neue Funktionen:
    ecke_zu_nah
    meint_ecke
    beenden
    r2d
    refresh
    clear
    zeichne_ecke
    zeichne_kante

Version 0.0.3 - 04.02.2003 (29.915 Byte - 800 Zeilen - ged_2003_02_04_a.pl)
~~~~~~~~~~~~~
- Men eingefgt.
- Skalaelement zur Grennderung des Radius der Eckendarstellung eingefgt.
- Nach Eckenlschen hhere Eckennummern korrigiert.
- Ausgabe aus beenden nach save verschoben, in beenden save aufgerufen.
- Debug-Startausgaben mit Funktionsnamen in jede Funktion eingebaut.
- In clear Motion-Bindung aufheben - Zeichenvorgang wird damit unterbrochen.
- Kantenzeichnen korrigiert.

Neue Funktionen:
    save
    ueber_ged (leerer Rumpf)
    neue_datei (leerer Rumpf)
    lade_datei (leerer Rumpf)
    speichere_datei (leerer Rumpf)
    speichere_datei_als (leerer Rumpf)


Version 0.0.4 - 04.02.2003 (48.289 Byte - 1253 Zeilen - ged_2003_02_04_b.pl)
~~~~~~~~~~~~~
- $Debug und $Dateiname als globale Variablen eingefhrt.
- $MW eingefhrt.
- Hilfemen um Graphenerklrung und "ber GED" erweitert.
- Acceleratoren im Men eingebaut (Tastenkrzelanzeige).
- Dummy-Bearbeitenmen und Internamen eingebaut.
- Einige Tastaturbindungen vorgenommen.
- bind_start erhlt jetzt das Canvas nicht mehr als Parameter
- Data::Dumper zu Debug-Zwecken verwendet.
- Einige Ausgaben von $Debug abhngig gemacht.
- beenden ruft nicht mehr save auf.
- clear erhlt jetzt das Canvas nicht mehr als Parameter und setzt die globalen
  Ecken / Kantenarrays auf leere Listen nachdem sie auf undef gesetzt wurden.
- zeichne_ecke bricht jetzt bei falschem Aufruf mit Fehler ab.
- zeichne_kante bricht jetzt bei falschem Aufruf mit Fehler ab.
- save schreibt in eine Datei ($Dateiname) und nicht nur auf den Bildschirm.
- ueber_ged, neue_datei, lade_datei, speichere_datei mit Leben gefllt,
  waren vorher leere Blcke.

Neue Funktionen:
    dump_data
    load
    graph_erkl
    zeige_daten_an
    hilfe
    dump_eingeben (noch ohne Funktionalitt)


Version 0.0.5 - 04.02.2003 (49.134 Byte - 1283 Zeilen - ged_2003_02_04_c.pl)
~~~~~~~~~~~~~
- Cwd zur Ermittlung des Arbeitsverzeichnisses verwendet. (-> $Pfad)
- in load Laden der Eckenzahl korrigiert und das Einlesen der Kanten eingebaut.
- $Pfad per -initialdir in speichere_datei_als verwendet.


Version 0.0.6 - 05.02.2003 (65.573 Byte - 1724 Zeilen - ged_2003_02_05.pl)
~~~~~~~~~~~~~
- $Debug wird als erste Variable definiert.
- Neue Methode "Ecke verschieben 2" (Linientyp).
- Linientyp "Linie" heit jetzt "Kante".
- Neue Methode "Kante lschen" (Linientyp).
- Statuszeilenausgaben an verschiedenen Stellen eingebaut.
- Speichern _unter_ statt Speichern _als_.
- ndern der Radiusgre fr die Eckenkreise fhrt jetzt ein automatisches
  refresh durch, d.h. man sieht die nderung gleich auf dem Bildschirm.
- Methoden zum Ecken verschieben (2 Stck) und Kanten lschen realisiert.
- Schleifen verhindert, d.h. Kanten drfen nur noch zwischen verschiedenen
  Ecken verlaufen.
- meint_ecke durch last beschleunigt.
- Parameter in clear() eingebaut, Bindungen werden nur auf Wunsch wieder
  hergestellt.
- Viele Ausgaben abhngig von $Debug gemacht (verschiedene Level).
- Titelanzeige bei neue_datei und lade_datei gendert.
- Doppelten Aufruf von Save in speichere_datei verhindert.
- -initialdir in speichere_datei_als ausgebaut, wird mit absolutem Pfad
  angegeben und fhrt dann zu Fehlern.
- graph_erkl mit neuem Toplevel-Window versehen.
- Hilfe mit neuem Toplevel-Window versehen.

Neue Funktionen:
    ecke_zu_nah_ohne
    meint_kante (aber noch nicht funktionstchtig...)


Version 0.0.7 - 08.02.2003 (71.673 Byte - 1863 Zeilen - ged_2003_02_08.pl)
~~~~~~~~~~~~~
- Linientyp "Ecke" in "Ecke einfgen" gendert.
- Icon fr GED erzeugt und dieses in tk_start dem MainWindow zugewiesen.
- Arbeitswerkzeugwahl nun ber Editbuttons am oberen Rand und nicht mehr ber
  Radioboxes am rechten Rand.


Version 0.0.8 - 10.02.2003 (88.312 Byte - 2249 Zeilen - ged_2003_02_10.pl)
~~~~~~~~~~~~~
- Linientypennamen gendert.
- Durchgngigen Menufont in allen Menelementen verwendet.
- Editbuttons in drei Gruppen (erzeugen, modifizieren und lschen) aufgeteilt
  und optisch voneinander abgesetzt.
- Tests eingebaut, so dass man keine Kante einfgen kann, wenn nur eine Ecke da
  ist etc.
- Kantenlschen: Kantenzahl runterzhlen und refresh eingebaut.
- Neues Icon auch bei "ber GED" verwendet.
- meint_kante mit der richtigen Funktion befllt.

Neue Funktionen:
    abstand_punkt_linie
    punkt_abstand
    floor
    do_all_the_tests


Version 0.0.9 - 11.02.2003 (95.174 Byte - 2401 Zeilen - ged_2003_02_11.pl)
~~~~~~~~~~~~~
- Gesamtes Mensystem umgestellt nach ausfhrlichem Schmkern in den perldocs
  (menu, ...), dies wurde in obigem Buch nicht vernnftig erklrt, jetzt hat
  das Programm ein richtig "normales" Men, in das man mit Alt-Buchstabe, Alt,
  F10 wechseln und in dem man mit den Cursortasten gewohnt navigieren kann.
- Linientypennamen gendert (Nacharbeiten).
- -initialfile rausgenommen in speichere_datei_als.


Version 0.0.10 - 12.02.2003 (98.898 Byte - 2492 Zeilen - ged_2003_02_12_a.pl)
~~~~~~~~~~~~~~
- Im Men Bearbeiten kann man nun Kreise und vollstndige Graphen einfgen
  (C3, C4, C5, C6, C7, C8, C9, K3, K4, K5, K6, K7).

Neue Funktionen:
    struktur_einfuegen


Version 0.0.11 - 12.02.2003 (107.338 Byte - 2669 Zeilen - ged_2003_02_12_b.pl)
~~~~~~~~~~~~~~
- Funtion todo eingefgt, ToDo-Texte sind als HERE-Dokument in diese Funktion
  gewandert.
- Grob geschtzte Versionsnummer $Version (5) und Datum $Datum eingefgt.
  Version und Datum werden nun bei "ber GED" angezeigt.
- Grafische Elemente (Icons etc.) ins Unterverzeichnis res verschoben.
- Weitere Kn's (K8 bis K13, K20, K30, K40, K50, K99), sowie Cn's (C20, C30,
  C40, C50, C99) sowie das Einfgen des Mittelpunktes in das Bearbeitenmen
  aufgenommen.
- ESC beendet nun nicht mehr das Programm, sondern Ctrl-B. Entsprechend wird
  ESC in den Diversen Funktionen mit eigenen Toplevel-Windows hinterher auch
  nicht wieder an $MW gebunden.
- Fehlermeldung in meint_kante ausgeben, wenn es uneindeutig ist.
- struktur_einfuegen erweitert / verbessert, Koordinatenberechnung ist nun
  richtig. Schleifeninvariante Variablen vor der Schleife deklariert und
  initialisiert.

Neue Funktionen:
    todo


Version 0.0.12 - 13.02.2003 (138.257 Byte - 3395 Zeilen - ged_2003_02_13.pl)
~~~~~~~~~~~~~~
- Speichern im LaTeX-Modus eingebaut
- Speichern im Postscript-Modus eingebaut
- Beim Doppelklick im Laden-Men wird nun dieser nicht mehr im Canvas ausgewer-
  tet, dank tK::after.
- Der ToDo-Text ist wieder an den Dateianfang gewandert, in eine globale
  Variable. (Here-Dokument)
- Diese History angelegt und teilweise rekonstruiert, Versionsnummern
  rckwirkend vergeben / korrigiert.
- Men "Bearbeiten 2" mit kascadierenden Submens als Alternative zu Men
  Bearbeiten eingefgt.
- Men Hilfe ist jetzt wieder rechtsbndig (durch letzten Seperator der
  Menubar!).
- In do_all_tests Zeilen umgebrochen, so dass sie in die ersten 80 Zeichen pro
  Zeile passen.

Neue Funktionen:
    history
    toLaTeX
    export_nach_latex
    export_nach_postscript


Version 0.0.13 vom 17.02.2003
~~~~~~~~~~~~~~
> 136.747 Byte - 3.405 Zeilen -      ged_2003_02_17.pl
>   5.816 Byte -   167 Zeilen - GEDfhist_2003_02_17.pm
> -------         ----
> 142.563 Byte - 3.572 Zeilen

- Verwaltung der zuletzt bearbeiteten Dateien in GEDfhist.pm / ged.pl eingebaut.
- Haupt-Men in globaler Variable $Menu zugnglich gemacht (um die vernderten
  bearbeiteten Dateien ins Men eintragen zu knnen).
  Dito $Menuefont, aber beide nur im Block mit tk_start und add_file_menu.
- Mainteil ans Ende verlegt, sonst sind die Blockvariablen nicht initialisiert.

Neue Funktionen:
    GEDfhist::load
    GEDfhist::save
    GEDfhist::add
    GEDfhist::array
    GEDfhist::min
    GEDfhist::max
    add
    add_file_menu


Version 0.0.14 vom 12.03.2003
~~~~~~~~~~~~~~
> 140.598 Byte - 3.519 Zeilen -      ged_2003_03_12.pl
>   5.816 Byte -   167 Zeilen - GEDfhist_2003_02_17.pm
> -------        -----
> 146.414 Byte - 3.686 Zeilen

- Funktion dump_eingeben mit Leben gefllt.

Neue Funktionen:
    dump_eingeben (war bisher nur ein Rumpf)
    load_dump (local in dump_eingeben)


Version 0.0.15 vom 18.03.2003
~~~~~~~~~~~~~~
> 142.919 Byte - 3.581 Zeilen -      ged_2003_03_18.pl
>   5.816 Byte -   167 Zeilen - GEDfhist_2003_02_17.pm
> -------        -----
> 148.735 Byte - 3.748 Zeilen

- Linientypen werden nun ber ein Hash definiert, das ein Krzel als Schlssel
  und den schnen Langtext als Wert hat. Gespeichert word nur der Schlssel,
  beim Laden werden Werte in Schlssel bertragen, um alte Dateien lesen zu
  knnen.
- Beim schnellen Eckenverschieben wird nun nicht mehr auf berschneidung mit
  der Ausgangsecke getestet.


Version 0.0.16 vom 05.02.2004
~~~~~~~~~~~~~~
> 151.988 Byte - 3.658 Zeilen -      ged_2004_02_05.pl
>   5.816 Byte -   167 Zeilen - GEDfhist_2003_02_17.pm
> -------        -----
> 157.804 Byte - 3.825 Zeilen

- Viele globale Variablen in Hashes %Konfig und %Graph zusammengefasst.


Version 0.0.17 vom 06.02.2004
~~~~~~~~~~~~~~
> 158.920 Byte - 3.840 Zeilen -      ged_2004_02_06.pl
>   5.816 Byte -   167 Zeilen - GEDfhist_2003_02_17.pm
> -------        -----
> 164.736 Byte - 4.007 Zeilen

- Einfgen von groben Kommentarblcken zur Abtrennung der Funktionen in
  Oberflche, Logik und Daten (Dateien), Sortieren der Funktionen.
- Verschieben der Kommentarblcke unter den Anfang der Sub's, damit man ganze
  Funktionen im Editor bersichtlich zusammenfalten kann.
- Es kann optional ein Gitterzetz in variabler Weite eingeblendet werden.
  (Geplant ist das Optionale Einrasten beim Setzen und Verschieben von Ecken
  auf den Ratserpunkten, die Variable und der Menpunkt sind auch schon da,
  die Funktionalitt fehlt aber noch.)

Neue Funktionen:
    tk_beenden


Version 0.0.18 vom 06.02.2004
~~~~~~~~~~~~~~
> 163.121 Byte - 3.982 Zeilen -    ged_2004_02_06_b.pl
>   5.554 Byte -   159 Zeilen - GEDfhist_2004_02_06.pm
> -------        -----
> 168.675 Byte - 4.141 Zeilen

- Einrastfunktion am Gitter eingebaut.
- Alle Funktionen mit Prototypen versehen und diese zu Beginn des Programms
  genannt.

Neue Funktionen:
    rast_ein


Version 0.0.19 vom 06.02.2004
~~~~~~~~~~~~~~
> 167.786 Byte - 4.108 Zeilen -    ged_2004_02_06_c.pl
>   5.554 Byte -   159 Zeilen - GEDfhist_2004_02_06.pm
> -------        -----
> 173.340 Byte - 4.267 Zeilen

- Schnittstelle von load und save gendert, nun muss der Dateiname als Para-
  meter angegeben werden.
- Neues Men "Manipulatoren" mit dem Punkt "In Liniengraphen umwandeln".
- Umwandlung des Graphen in seinen Liniengraphen

Neue Funktionen:
    erzeuge_liniengraphen


Version 0.0.20 vom 06.02.2004
~~~~~~~~~~~~~~
> 179.181 Byte - 4.418 Zeilen -    ged_2004_02_06_d.pl
>   5.554 Byte -   159 Zeilen - GEDfhist_2004_02_06.pm
> -------        -----
> 184.735 Byte - 4.577 Zeilen

- Funktion zur Ermittlung der Canvasgre vorbereitet und in refresh() und
  struktur_einfuegen() eingebaut. Bisher wird aber nur ein fest eingetragenes
  Gren-Quadrupel zurckgegeben.
- Verschiedenen Funktionen rund um Kanten und Ecken hinzugefgt und an anderen
  Stellen aufgerufen. (Verlagerung von Komplexitt).
- Eckenmergen realisiert.
- Todo-Texte aufgerumt.

Neue Funktionen:
    canvas_groesse
    ecke_einfuegen
    ecke_loeschen
    ecke_mergen
    kante_existiert
    kante_einfuegen
    kante_loeschen


Version 0.0.21 vom 07.02.2004
~~~~~~~~~~~~~~
> 182.814 Byte - 4.489 Zeilen -      ged_2004_02_07.pl
>   5.554 Byte -   159 Zeilen - GEDfhist_2004_02_06.pm
> -------        -----
> 188.368 Byte - 4.648 Zeilen

- Geometry zur Grenermittlung in canvas_groesse() verwendet.
- Refresh wird jetzt per Event bei Grennderungen des Fensters aufgerufen,
  so dass das Gitter und auch die eingefgten Graphen an die aktuelle
  Fenstergre angepasst werden.
- Ecken und Kantenfarbe ist nun nicht mehr fest rot/schwarz, sondern
  variabel $Graph{eckenfarbe} bzw. $Graph{kantenfarbe}.
- Ecken- und Kantenfarbe ber Men Ansicht whlbar.
- Waitcursor bei Liniengraphenberechnung eingeschaltet.


Version 0.0.22 vom 08.02.2004
~~~~~~~~~~~~~~
> 179.294 Byte - 4.374 Zeilen -      ged_2004_02_08.pl
>   5.584 Byte -   162 Zeilen - GEDfhist_2004_02_08.pm
> -------        -----
> 184.878 Byte - 4.536 Zeilen

- mit "use Tk::ErrorDialog;" werden jetzt grafische Fehlermeldungen erzeugt.
- anzeige_fenster() zum einfacheren Anzeigen der Daten in zeige_daten_an(),
  hilfe(), graph_erkl(), history() und todo() verwendet.

Neue Funktionen:
    anzeige_fenster


Version 0.0.23 vom 08.02.2004
~~~~~~~~~~~~~~
> 181.451 Byte - 4.425 Zeilen -    ged_2004_02_08_b.pl
>   5.584 Byte -   162 Zeilen - GEDfhist_2004_02_08.pm
> -------        -----
> 187.035 Byte - 4.587 Zeilen

- mit "use Tk::ErrorDialog;" werden jetzt grafische Fehlermeldungen erzeugt.
- anzeige_fenster() zum einfacheren Anzeigen der Daten in zeige_daten_an(),
  hilfe(), graph_erkl(), history() und todo() verwendet.
- Bug der nicht mehr funktionierenden Linienarten auer normal behoben (es
  fehlte ein Komma vor einem weiteren eingefgten Parameter [-fill]
  von createLine() hinter -arrowshape).


Version 0.0.24 vom 09.02.2004
~~~~~~~~~~~~~~
> 156.599 Byte - 3.713 Zeilen -      ged_2004_02_09.pl
>   5.584 Byte -   162 Zeilen - GEDfhist_2004_02_08.pm
>   9.064 Byte -   273 Zeilen -  GEDgeom_2004_02_08.pm
>  21.437 Byte -   528 Zeilen -    Graph_2004_02_09.pm
>  31.765 Byte -   776 Zeilen -  Graph2D_2004_02_09.pm
> -------        -----
> 224.449 Byte - 5.452 Zeilen

- linientyp, startecke, zx und zy sind jetzt nicht mehr in %Graph, sondern in
  %Konfig, da diese Informationen inhaltlich nicht zum Graphen, sondern zum
  Zeichnen desselben whrend des Linienziehens dienen.
- Gitterfarbe jetzt ber %Konfig einstellbar, nicht mehr in der Funktion hart
  verdrahtet.
- Funktionalitt ins neue Modul GEDgeom.pm ausgelagert (abstand_punkt_linie,
  punkt_abstand [und floor]).
- Erstes Bearbeiten Men auskommentiert.
- Menpunkt Ansicht erneuern aus dem Dateimen entfernt (ist auch im
  Ansichtsmen gewesen)
- Neue Klasen Graph und Graph2D, in die viel Funktionalitt ausgelagert wurde.

Ausgelagerte Funktionen (gelscht):
    ecke_zu_nah
    ecke_zu_nah_ohne
    meint_ecke
    meint_kante
    r2d
    ecke_einfuegen
    ecke_loeschen
    ecke_mergen
    kante_existiert
    kante_einfuegen
    kante_loeschen

Ausgelagerte Funktionalitten (entkernt):
    clear
    struktur_einfuegen
    erzeuge_liniengraphen

Neue Funktionen:
    waehle_eckenfarbe
    waehle_kantenfarbe


Funktionen in GEDgeom.pm:
    abstand_punkt_linie
    punkt_abstand
    floor

Methoden in Graph:
    new
    _property
    n
    m
    kantenform
    KantenA
    KantenE
    Kantenform
    ecke_einfuegen
    ecke_loeschen
    ecke_mergen
    kante_existiert
    kante_einfuegen
    kante_loeschen
    clear

Methoden in Graph2D:
    new
    radius
    delta
    eckenfarbe
    kantenfarbe
    EckenX
    EckenY
    ecke_einfuegen
    ecke_loeschen
    ecke_mergen
    clear
    ecke_zu_nah
    ecke_zu_nah_ohne
    meint_ecke
    meint_kante
    r2d
    struktur_einfuegen
    erzeuge_liniengraphen


Version 0.0.25 vom 09.02.2004
~~~~~~~~~~~~~~
> 161.976 Byte - 3.822 Zeilen -     ged_2004_02_09_b.pl
>   5.875 Byte -   177 Zeilen -  GEDfhist_2004_02_09.pm
>   9.358 Byte -   291 Zeilen -   GEDgeom_2004_02_09.pm
>  21.707 Byte -   545 Zeilen -   Graph_2004_02_09_b.pm
>  32.073 Byte -   795 Zeilen - Graph2D_2004_02_09_b.pm
> -------        -----
> 230.989 Byte - 5.630 Zeilen

- Bug beseitigt der Auftrat, wenn man im Gitterraster einrasten mchte ohne
  es anzuzeigen.
- Eckenradiuseinstellung von der Oberflche ins Men verlagert (abreibar)
- Gitterweitenmen abreibar gemacht
- Fehler behoben: Wurde im Farbwahlmen ESC gedrckt, so kommt keine Farbe
  zurck und die dargestellten Dinge (Ecken bzw. Kanten) verschwanden.
- POD angefangen mit Titel und Copyright, um die Sourcen zum Download anbieten
  zu knnen. (Sie sind damit unter der Doppellizenz GPL / artistic, siehe
  perldoc perlgpl bzw. perldoc perlartistic.)


Version 0.0.26 vom 10.02.2004
~~~~~~~~~~~~~~
> 163.838 Byte - 3.884 Zeilen -      ged_2004_02_10.pl
>   5.875 Byte -   177 Zeilen - GEDfhist_2004_02_09.pm
>   9.358 Byte -   291 Zeilen -  GEDgeom_2004_02_09.pm
>  25.986 Byte -   676 Zeilen -    Graph_2004_02_10.pm
>  37.248 Byte -   941 Zeilen -  Graph2D_2004_02_10.pm
>   7.283 Byte -   173 Zeilen -     Ecke_2004_02_10.pm
>   8.403 Byte -   199 Zeilen -    Kante_2004_02_10.pm
> -------        -----
> 257.991 Byte - 6.343 Zeilen

- Klassen fr Ecken und Kanten eingefhrt und die Graphenklassen um Hilfs-
  funktionen erweitert, so dass die interne Datenstruktur vor ged.pl total
  gekapselt ist.

Neue Methoden in Graph:
    _kanten
    setze_kanten
    loesche_kanten
    kante
    entnehme_kante
    fuege_kante_hinzu

Neue Methoden in Graph2D:
    new
    _ecken
    setze_ecken
    loesche_ecken
    ecke
    entnehme_ecke
    fuege_ecke_hinzu

Methoden in Ecke.pm:
    new
    _property
    x
    y

Methoden in Kante.pm:
    new
    _property
    a
    e
    form
    inzidiert_mit_ecke

Version 0.0.27 vom 10.02.2004
~~~~~~~~~~~~~~
> 164.922 Byte - 3.905 Zeilen -     ged_2004_02_10_b.pl
>   5.884 Byte -   177 Zeilen -     FHist_2004_02_10.pm
>   9.367 Byte -   291 Zeilen -      Geom_2004_02_10.pm
>  26.238 Byte -   676 Zeilen -   Graph_2004_02_10_b.pm
>  37.453 Byte -   941 Zeilen - Graph2D_2004_02_10_b.pm
>   7.295 Byte -   173 Zeilen -    Ecke_2004_02_10_b.pm
>   8.417 Byte -   199 Zeilen -   Kante_2004_02_10_b.pm
> -------        -----
> 259.576 Byte - 6.363 Zeilen

- Alle Module in den Namensraum Graph::GED:: verschoben.
- Tippfehler bei Load "for," statt "form" verbessert.

Version 0.0.28 vom 10.02.2004
~~~~~~~~~~~~~~
> 167.508 Byte - 3.905 Zeilen -     ged_2004_02_10_c.pl
>   5.884 Byte -   177 Zeilen -     FHist_2004_02_10.pm
>   9.367 Byte -   291 Zeilen -      Geom_2004_02_10.pm
>  25.045 Byte -   651 Zeilen -   Graph_2004_02_10_c.pm
>  40.159 Byte - 1.000 Zeilen - Graph2D_2004_02_10_c.pm
>   4.019 Byte -   111 Zeilen -    Ecke_2004_02_10_c.pm
>   5.149 Byte -   139 Zeilen -   Kante_2004_02_10_c.pm
>   8.480 Byte -   200 Zeilen -     Basis_2004_02_10.pm
>   4.656 Byte -   123 Zeilen -  Historie_2004_02_10.pm
> -------        -----
> 270.267 Byte - 6.653 Zeilen

- Basisklasse hinzugefgt, von der alle Klassen abgeleitet werden.
  Dadurch entfllt _property in allen anderen Klassen und alle new-
  Methoden werden einfacher.
  Die Methode clone muss von allen Klassen, die Kontainer in ihrem Hash
  haben, vie Graph, Graph2D berschrieben werden, damit
  nicht die Referenzen auf die Kontainer, sondern die Inhalte kopiert
  werden.
  Clonefunktionalitt noch nicht fertig, daher auskommentiert.
- Rumpfklasse Graph::GED::Historie fr Zurcknahme und Wiederholung
  angelegt (noch ohne Inhalt und ohne Verwendung. Bentig das clonen.
- Einige Fehler ausgemerzt, wo "Graph::GED::" noch fehlte, etwa beim
  Ermitteln der Canvasausdehnung (eingefgte Kreise und vollstndige
  Graphen landeten dadurch in der oberen linken Ecke).

Methoden in Basis.pm:
    new
    _property
    clone


Version 0.0.29 vom 11.02.2004
~~~~~~~~~~~~~~
>  10.118 Byte -   253 Zeilen -    Graph::GED::Basis.pm
>   4.502 Byte -   139 Zeilen -     Graph::GED::Ecke.pm
>   5.884 Byte -   177 Zeilen -    Graph::GED::FHist.pm
>   9.367 Byte -   291 Zeilen -     Graph::GED::Geom.pm
>  27.736 Byte -   713 Zeilen -    Graph::GED::Graph.pm
>  40.250 Byte - 1.003 Zeilen -  Graph::GED::Graph2D.pm
>   4.656 Byte -   123 Zeilen - Graph::GED::Historie.pm
>   5.149 Byte -   139 Zeilen -    Graph::GED::Kante.pm
> 170.704 Byte - 4.042 Zeilen -                  ged.pl
> -------        -----
> 278.366 Byte - 6.880 Zeilen

- Clonefunktionalitt fertig gestellt.
- POD bei einigen Klassen weiter gefllt.

Neue Funktionen:
    clone_test
    Graph::GED::Graph2D::clone
    Graph::GED::Graph::clone
    Graph::GED::Basis::clone


Version 0.0.30 vom 12.02.2004
~~~~~~~~~~~~~~
>  10.131 Byte -   255 Zeilen -    Graph::GED::Basis.pm
>   4.502 Byte -   139 Zeilen -     Graph::GED::Ecke.pm
>   6.250 Byte -   181 Zeilen -    Graph::GED::FHist.pm
>   9.372 Byte -   291 Zeilen -     Graph::GED::Geom.pm
>  27.772 Byte -   714 Zeilen -    Graph::GED::Graph.pm
>  42.383 Byte - 1.033 Zeilen -  Graph::GED::Graph2D.pm
>   4.656 Byte -   123 Zeilen - Graph::GED::Historie.pm
>   5.149 Byte -   139 Zeilen -    Graph::GED::Kante.pm
>   8.102 Byte -   194 Zeilen -  Graph::GED::TkTools.pm
> 162.796 Byte - 3.888 Zeilen -                  ged.pl
> -------        -----
> 281.113 Byte - 6.957 Zeilen

- Kapselung der interenen Kanten/Ecken zusammenhnge durch vier Hilfsfunktionen
  in Graph::GED::Graph2D (x_von_a, y_von_a, x_von_e und y_von_e), welche die
  Koordinaten der Ecken ausgeben, die mit der Kante inzidieren.
  Dann muss man spter nur hier ndern, falls man doch mal die Ecken direkt in
  die Kanten aufnehmen will.
- use FindBin; use lib "$FindBin::RealBin"; verwendet, damit man das Programm
  (ohne Installation) nicht nur aus dem ged-Verzeichnis aus starten kann.
- Neues Modul Graph::GED::TkTools;
  Darein anzeige_fenster ausgelagert und als optionalen Parameter eine Wahl
  eingefhrt, ob der erzeugte "Dialog" modal sein soll.
- Alle Hilfefenster unmodal gemacht.
- Stellen ausgemerzt, an denen trotz debug auf 0 noch etwas ausgegeben wurde.
  (Hoffentlich alle.)

Neue Funktionen / Methoden:
    Graph::GED::Graph2D::x_von_a
    Graph::GED::Graph2D::y_von_a
    Graph::GED::Graph2D::x_von_e
    Graph::GED::Graph2D::y_von_e
    Graph::GED::Graph2D::x_von_a_index
    Graph::GED::Graph2D::y_von_a_index
    Graph::GED::Graph2D::x_von_e_index
    Graph::GED::Graph2D::y_von_e_index
    Graph::GED::TkTools::anzeige_fenster


Version 0.0.31 beta
~~~~~~~~~~~~~~~~~~~

Ich habe meinen Grapheneditor um eine Historienfunktion
erweitert. Diese Funktionalitt ist in einer extra
Klasse (Historie.pm, Graph::GED::Historie) enthalten,
die Klasse kann alle mglichen (von Graph::GED::Basis
abgeleiteten) Objekte speichern und verwalten.

Somit ist sie spter universell einsetzbar, wenn alle
Fehler behoben sind. Die Ableitung von Graph::GED::Basis
ist deshalb ntig, weil die verwalteten Objekte eine clone-
und eine clear-Methode haben mssen, beides wird u.a. von
Graph::GED::Basis zur Verfgung gestellt.

Diese beiden Methoden kmmern sich um das saubere ko-
pieren bzw. Lschen der verwalteten Objekte. Dies wird
dann wichtig, wenn die Objekte nicht nur "flache Daten"
enthalten, sondern anonyme Arrays oder Hashes.

(Genaugenommen prfe ich auch nicht auf die Ableitung von
Graph::GED::Basis, sondern nur, ob die bergebenen
Objekte die Methoden clone und clear beherrschen (mit can).)

Die Historie ist eine State-Machine (wem das nichts sagt:
es gibt verschiedene Zustnde und definierte bergnge
von Zustand zu Zustand und die Maschine "wei", was sie
in welchem Zustand bei welcher Anforderung machen soll).

Ich unterscheide folgende Zustnde:
    NORMAL
    NORMAL_ENDE
    NACH_RUECK
    NACH_RUECK_ANFANG
    NACH_WIEDER
    NACH_WIEDER_ENDE

Folgende "Anforderungen" bzw. von auen zugngliche
Methoden gibt es (neben new, clone und max):
    objekt_eintragen()
    rueckgaengig()
    wiederholung()

Zum Testen gibt es im Moment nur drei Speicherpltze in der
Historie, das werde ich natrlich spter auch hochsetzen.

(Die Kommentarbeschreibung der Aktionen in den verschiedenen
Stati stimmt noch nicht, das werde ich nachbessern, wenn alle
Fehler behoben sind.)

Das Historienobjekt in ged.pl selbst ist in %Konfig
unter dem Schlssel historie enthalten.
Es wird am Anfang mit new Graph::GED::Historie angelegt.

Das meiste funktioniert schon, aber mir ist noch ein Fehler
aufgefallen, den ich aber nicht genau lokalisieren und auch
nicht wiederholen konnte.

In der Betaversion ist in Graph/GED/Historie.pm der Debug-Level
auf 2, es gibt eine Extraausgabe in
    [tt]historie_schalter_aktualisieren()[/tt]
in ged.pl und die Fehlerausgaben in Tk-Fenster sind momentan
ausgeschaltet. Das wird spter gendert.


Neue Funktionen / Methoden:
    historie_test
    rueckgaengig
    wiederholung
    aenderung
    historie_schalter_aktualisieren
    Graph::GED::Historie::_hist_eintrag
    Graph::GED::Historie::_hist_loesch_ersten_eintrag
    Graph::GED::Historie::_hist_loesch_eintrag
    Graph::GED::Historie::clone
    Graph::GED::Historie::objekt_eintragen
    Graph::GED::Historie::rueckgaengig
    Graph::GED::Historie::wiederholung
    Graph::GED::Historie::geaendert


noch zu tun nach Abschlu beta-Test:
    Kommentartabelle in Historie an Realitt anpassen
    Windows-Fehlermeldung wieder anschalten in ged.pl
    meldung in historie_schalter_aktualisieren ausstellen
    Debug in Historie auf 0
    beta aus Versionsnummer raus


Version 0.0.31 vom 08.12.2004
~~~~~~~~~~~~~~
>  12.060 Byte -   302 Zeilen -    Graph::GED::Basis.pm
>   4.514 Byte -   139 Zeilen -     Graph::GED::Ecke.pm
>   6.250 Byte -   181 Zeilen -    Graph::GED::FHist.pm
>   9.372 Byte -   291 Zeilen -     Graph::GED::Geom.pm
>  27.018 Byte -   697 Zeilen -    Graph::GED::Graph.pm
>  42.883 Byte - 1.042 Zeilen -  Graph::GED::Graph2D.pm
>  40.401 Byte - 1.001 Zeilen - Graph::GED::Historie.pm
>   5.149 Byte -   139 Zeilen -    Graph::GED::Kante.pm
>   8.102 Byte -   194 Zeilen -  Graph::GED::TkTools.pm
> 179.335 Byte - 4.297 Zeilen -                  ged.pl
> -------        -----
> 335.084 Byte - 8.283 Zeilen

- Funktion Graph::GED::Historie::_hist_loesch_ersten_eintrag repariert.
- Funktion Graph::GED::Historie::_konsistent repariert.

Die Historie funktioniert noch nicht einwandfrei, aber weitgehend, so dass sie
fr das Programm freigeschaltet wird.

noch zu tun:
    Kommentartabelle in Historie an Realitt anpassen


Version 0.0.32 vom 01.01.2005
~~~~~~~~~~~~~~
>  12.060 Byte -   302 Zeilen -    Graph::GED::Basis.pm
>   6.950 Byte -   198 Zeilen -     Graph::GED::Ecke.pm
>   6.364 Byte -   185 Zeilen -    Graph::GED::FHist.pm
>   9.434 Byte -   289 Zeilen -     Graph::GED::Geom.pm
>  27.022 Byte -   697 Zeilen -    Graph::GED::Graph.pm
>  60.143 Byte - 1.567 Zeilen -  Graph::GED::Graph2D.pm
>  40.356 Byte -   999 Zeilen - Graph::GED::Historie.pm
>   8.041 Byte -   229 Zeilen -    Graph::GED::Kante.pm
>   8.175 Byte -   193 Zeilen -  Graph::GED::TkTools.pm
> 209.437 Byte - 5.011 Zeilen -                  ged.pl
> -------        -----
> 387.982 Byte - 9.670 Zeilen

- Neues Graphenformat 'ged2' eingefhrt: Die Eckeneigenschaften Farbe, Radius,
  Beschriftung, Wert, Ausrichtung der Beschriftung und Ausrichtung des Wertes
  und die Kanteneigenschaften Farbe, Stil, Beschriftung, Wert, Ausrichtung der
  Beschriftung und Ausrichtung des Wertes werden mit abgespeichert und geladen.
  Auerdem noch die Standardwerte fr Eckenfarbe, Radius und Kantenfarbe.
  (Beim Laden und Speichern stehen nun die Formate ged und ged2 zur Verfgung.)
- Kontextmen fr Ecken und Kanten hinzugefgt. Auer den neuen obigen
  Eigenschaften kann man darber auch Ecken mergen, lschen, am Gitter
  ausrichten und Kanten lschen und Kantenformen und -stile ndern.
- Ausgabe des Graphen als Dump im internen Men.
- ToDo-Liste berarbeitet.
- Gitter wird nach Lschen angezeigt, falls dies vorher der Fall war.
- Funktionalitt aus save und load nach Graph2D ausgelagert.
- Neue Attribute und Getter / Setter fr obige Eigentschaften in
  Graph::GED::Ecke.pm und Graph::GED::Kante.pm.
- Dokumentationen (pod).

Neue Funktionen / Methoden:
    zeige_daten_an_dumper
    context_menu
    tk_cm_farbwahl_klein
    tk_cm_groessenwahl
    tk_cm_kantenformwahl
    tk_cm_kantenstilwahl
    tk_cm_titelwahl
    tk_cm_titelausrichtung
    tk_cm_wertwahl
    tk_cm_wertausrichtung
    Graph::GED::Ecke::farbe
    Graph::GED::Ecke::radius
    Graph::GED::Ecke::titel
    Graph::GED::Ecke::gewicht
    Graph::GED::Ecke::titelpos
    Graph::GED::Ecke::gewichtpos
    Graph::GED::Kante::farbe
    Graph::GED::Kante::stil
    Graph::GED::Kante::titel
    Graph::GED::Kante::gewicht
    Graph::GED::Kante::titelpos
    Graph::GED::Kante::gewichtpos
    Graph::GED::Graph2D::save_ged
    Graph::GED::Graph2D::load_ged
    Graph::GED::Graph2D::save_ged2
    Graph::GED::Graph2D::load_ged2


Version 0.0.33 vom 02.01.2005
~~~~~~~~~~~~~~
>  12.060 Byte -    302 Zeilen -    Graph::GED::Basis.pm
>   6.950 Byte -    198 Zeilen -     Graph::GED::Ecke.pm
>   6.364 Byte -    185 Zeilen -    Graph::GED::FHist.pm
>   9.434 Byte -    289 Zeilen -     Graph::GED::Geom.pm
>  27.022 Byte -    697 Zeilen -    Graph::GED::Graph.pm
>  61.731 Byte -  1.600 Zeilen -  Graph::GED::Graph2D.pm
>  40.356 Byte -    999 Zeilen - Graph::GED::Historie.pm
>   8.407 Byte -    237 Zeilen -    Graph::GED::Kante.pm
>  11.350 Byte -    281 Zeilen -  Graph::GED::TkTools.pm
> 220.957 Byte -  5.214 Zeilen -                  ged.pl
> -------        ------
> 404.631 Byte - 10.002 Zeilen

- Kantendicke eingefhrt. Das ged2-Format wurde um die Dicke ergnzt.
  Vorbergehend wird beim Einlesen von ged2 auf die Dicke nicht geprft, so
  dass auch mit Version 0.0.32 erstellten ged2-Dateien eingelesen werden
  knnen.
- Kantenstil (normal, gestrichelt odeer gepunktelt) dargestellt.
- Die Kanten werden nicht mehr von Eckenmitte zu Eckenmitte gezogen, sondern
  von Eckenrand zu Eckenrand.
- Refresh nach Kanten ziehen fr Zeichnung von Eckenrand zu Eckenrand
- Bercksichtigung individueller Eckenradien in Graph2D::meint_ecke().
  Neue Berechnung von delta aus dem radius.
- tk_cm_farbwahl_klein() durch Graph::GED::TkTools::farbwahl() ersetzt.
  Dadurch fllt diese Funktion weg.
- Kommentarpflege in Graph::GED::TkTools (pod).
- Hintergrundfarbe wird jetzt im Graphen mit gespeichert und lsst sich via
  Men und via Kontextmen whlen.

Neue Funktionen / Methoden:
    tk_cm_kantendicke
    Graph::GED::Kante::dicke
    Graph::GED::TkTools::farbwahl
    Graph::GED::Graph2D::hintergrund

Entfernte Funktionen / Methoden:
    tk_cm_farbwahl_klein


Version 0.0.34 vom 03.01.2005
~~~~~~~~~~~~~~
>  12.060 Byte -    302 Zeilen -    Graph::GED::Basis.pm
>   7.918 Byte -    218 Zeilen -     Graph::GED::Ecke.pm
>   6.364 Byte -    185 Zeilen -    Graph::GED::FHist.pm
>   9.434 Byte -    289 Zeilen -     Graph::GED::Geom.pm
>  27.022 Byte -    697 Zeilen -    Graph::GED::Graph.pm
>  67.667 Byte -  1.727 Zeilen -  Graph::GED::Graph2D.pm
>  40.356 Byte -    999 Zeilen - Graph::GED::Historie.pm
>   9.427 Byte -    257 Zeilen -    Graph::GED::Kante.pm
>  12.203 Byte -    294 Zeilen -  Graph::GED::TkTools.pm
> 256.160 Byte -  6.010 Zeilen -                  ged.pl
> -------        ------
> 448.611 Byte - 10.978 Zeilen 

- Ankerberechnungen beim Zeichnen von Ecken und Kanten vereinfacht.
- Planung fr neues Speicherformat GED3 (siehe ToDo-Liste).
- Gitterwerte liegen jetzt in $Graph und werden im ged2-Format auch mit
  abgespeichert und geladen.
- Alle Perdocs knnen ber das Hilfe-Men gesichtet werden.
- Anzeigefensterfunktion in Graph::GED::TkTools um Bindungen erweitert,
  insbesondere kann nun per Mausrad gescrollt werden.
- Gitterfarbe ist nun whlbar.
- nderungsanzeige rechts unten neben der Statusbar ('*' => gendert).
  Beim Beenden wird jetzt nachgefragt, falls nicht gesicherte nderungen
  vorliegen.
- Inhalt Lschen im Dateimen.
- Fr Ecken- und Kantenbeschreibungen und -gewichte sind jetzt Farben whlbar.
  Diese Farben werden auch im ged2-Format mit abgespeichert.
- Die Gittereinstellungen sind nun auch per Kontextmen mglich.
  Defaulteckenfarbe und -kantenfarbe lsst sich jetzt auch per Kontextmen
  einstellen.
- Tooltip-Hilfe fr die Bedienelemente wird in der Statuszeile angezeigt.

Neue Funktionen / Methoden:
    Graph::GED::Graph2D::radius2delta
    perldoc_graph_ged_basis_pm
    perldoc_graph_ged_ecke_pm
    perldoc_graph_ged_kante_pm
    perldoc_graph_ged_graph_pm
    perldoc_graph_ged_graph2d_pm
    perldoc_graph_ged_geom_pm
    perldoc_graph_ged_historie_pm
    perldoc_graph_ged_fhist_pm
    perldoc_graph_ged_tktools_pm


Version 0.0.35 vom 14.01.2005
~~~~~~~~~~~~~~
>  12.060 Byte -    302 Zeilen -    Graph::GED::Basis.pm
>   7.918 Byte -    218 Zeilen -     Graph::GED::Ecke.pm
>   6.364 Byte -    185 Zeilen -    Graph::GED::FHist.pm
>   9.434 Byte -    289 Zeilen -     Graph::GED::Geom.pm
>  27.022 Byte -    697 Zeilen -    Graph::GED::Graph.pm
>  69.733 Byte -  1.776 Zeilen -  Graph::GED::Graph2D.pm
>  40.356 Byte -    999 Zeilen - Graph::GED::Historie.pm
>   9.427 Byte -    257 Zeilen -    Graph::GED::Kante.pm
>  12.203 Byte -    294 Zeilen -  Graph::GED::TkTools.pm
> 269.067 Byte -  6.301 Zeilen -                  ged.pl
> -------        ------
> 463.584 Byte - 11.318 Zeilen

- aenderung() vor dem Beginn von Ecken-Verschiebungen aufgerufen statt am Ende.
- Ecken- und Kantennummern werden auf Wunsch angezeigt.
- Neuer Button zum Lschen aller getroffenen Kanten.
- Anzeige der internen Struktur im GED2-Format.
- Alle Pfade zu den Bilderdateien um "$FindBin::RealBin/" vorweg ergnzt, so
  dass man ged nicht aus dem ged-Verzeichnis heraus aufrufen muss.
- Hintergrundbild lsst sich laden, speichern, auswhlen (ber Men und
  Kontextmen).

Neue Funktionen / Methoden:
    zeige_daten_an2
    Graph::GED::Graph2D::hintergrundbild


Version 0.0.36 vom 16.01.2005
~~~~~~~~~~~~~~
>  12.060 Byte -    302 Zeilen -    Graph::GED::Basis.pm
>   7.918 Byte -    218 Zeilen -     Graph::GED::Ecke.pm
>   6.364 Byte -    185 Zeilen -    Graph::GED::FHist.pm
>   9.434 Byte -    289 Zeilen -     Graph::GED::Geom.pm
>  27.022 Byte -    697 Zeilen -    Graph::GED::Graph.pm
>  78.770 Byte -  1.998 Zeilen -  Graph::GED::Graph2D.pm
>  40.356 Byte -    999 Zeilen - Graph::GED::Historie.pm
>   9.643 Byte -    260 Zeilen -    Graph::GED::Kante.pm
>  12.203 Byte -    294 Zeilen -  Graph::GED::TkTools.pm
> 265.375 Byte -  6.209 Zeilen -                  ged.pl
> -------        ------
> 469.145 Byte - 11.451 Zeilen

- Defaultkantendicke ist jetzt nicht mehr 1, sondern wird im Graphen mit
  abgespeichert und ist ber das Men whlbar.
- Menbeschriftung im Ansichtsmen um "Default " ergnzt (Eckenfarbe,
  Kantenfarbe...).
- Dateiname wird jetzt in $Graph gehalten und mit abgespeichert.
  Der Grund ist, dass dies bei der Animation ntig ist.
  Sollte die Datei gendert werden, so wird der flasche gespeicherte Name beim
  Laden durch den richtigen berschrieben.
- Anzeige der Daten in ged-Formaten erfolgt jetzt ber Speicherung in einer
  temporren Datei.
- Graph2d nach Graph2D umbenannt im Dateinamen und Klasse einheitlich.
- toLaTeX nach Graph2D verschoben.

Neue Funktionen / Methoden:
    Graph::GED::Graph2D::kantendicke
    Graph::GED::Graph2D::dateiname
    Graph::GED::Graph2D::save
    Graph::GED::Graph2D::load
    Graph::GED::Graph2D::toLaTeX

Entfernte Funktionen / Methoden:
    zeige_daten_an2
    toLaTeX


Version 0.0.37 vom 16.01.2005
~~~~~~~~~~~~~~
>  12.060 Byte -    302 Zeilen -    Graph::GED::Basis.pm
>   7.918 Byte -    218 Zeilen -     Graph::GED::Ecke.pm
>   6.364 Byte -    185 Zeilen -    Graph::GED::FHist.pm
>   9.434 Byte -    289 Zeilen -     Graph::GED::Geom.pm
>  27.022 Byte -    697 Zeilen -    Graph::GED::Graph.pm
>  96.490 Byte -  2.336 Zeilen -  Graph::GED::Graph2D.pm
>  40.356 Byte -    999 Zeilen - Graph::GED::Historie.pm
>   9.643 Byte -    260 Zeilen -    Graph::GED::Kante.pm
>  12.203 Byte -    294 Zeilen -  Graph::GED::TkTools.pm
> 221.184 Byte -  5.094 Zeilen -                  ged.pl
> -------        ------
> 442.674 Byte - 10.674 Zeilen

- Neues Graphenformat 'ged3' eingefhrt.
- Buttons zum Verschieben des Graphen eingebaut.

Neue Funktionen / Methoden:
    Graph::GED::Graph2D::save_ged3
    Graph::GED::Graph2D::load_ged3
    nach_links
    nach_rechts
    nach_oben
    nach_unten


Version 0.0.38 vom 17.01.2005
~~~~~~~~~~~~~~
>  12.060 Byte -    302 Zeilen -    Graph::GED::Basis.pm
>   7.918 Byte -    218 Zeilen -     Graph::GED::Ecke.pm
>   6.364 Byte -    185 Zeilen -    Graph::GED::FHist.pm
>   9.434 Byte -    289 Zeilen -     Graph::GED::Geom.pm
>  27.022 Byte -    697 Zeilen -    Graph::GED::Graph.pm
> 109.627 Byte -  2.704 Zeilen -  Graph::GED::Graph2D.pm
>  40.356 Byte -    999 Zeilen - Graph::GED::Historie.pm
>   9.643 Byte -    260 Zeilen -    Graph::GED::Kante.pm
>  12.203 Byte -    294 Zeilen -  Graph::GED::TkTools.pm
> 271.774 Byte -  6.364 Zeilen -                  ged.pl
> -------        ------
> 506.401 Byte - 12.312 Zeilen

- Verschiebebuttons mit transparentem Hintergrund, so dass sie grau und nicht
  mehr wei erscheinen.
- nach_links etc. nach Graph2D verschoben.
- Buttons und Funktionalitt fr Zentrieren und Zentrieren/Skalieren eingebaut.
- Balloon-Texte fr Bewegungs- und Skalierungsbuttons hinzugefgt.
- Verschiebung erfolgt jetzt um Gitterweite.

Neue Funktionen / Methoden:
    Graph::GED::Graph2D::zentrieren
    Graph::GED::Graph2D::zentrieren_skalieren
    Graph::GED::Graph2D::kleiner
    Graph::GED::Graph2D::groesser
    Graph::GED::Graph2D::nach_links
    Graph::GED::Graph2D::nach_rechts
    Graph::GED::Graph2D::nach_oben
    Graph::GED::Graph2D::nach_unten

Entfernte Funktionen / Methoden:
    nach_links
    nach_rechts
    nach_oben
    nach_unten


Version 0.0.39 vom 17.01.2005
~~~~~~~~~~~~~~
>  12.060 Byte -    302 Zeilen -    Graph::GED::Basis.pm
>   7.918 Byte -    218 Zeilen -     Graph::GED::Ecke.pm
>   6.364 Byte -    185 Zeilen -    Graph::GED::FHist.pm
>   9.434 Byte -    289 Zeilen -     Graph::GED::Geom.pm
>  27.022 Byte -    697 Zeilen -    Graph::GED::Graph.pm
> 110.038 Byte -  2.715 Zeilen -  Graph::GED::Graph2D.pm
>  40.356 Byte -    999 Zeilen - Graph::GED::Historie.pm
>   9.643 Byte -    260 Zeilen -    Graph::GED::Kante.pm
>  12.203 Byte -    294 Zeilen -  Graph::GED::TkTools.pm
> 276.125 Byte -  6.487 Zeilen -                  ged.pl
> -------        ------
> 511.163 Byte - 12.446 Zeilen

- Contextmens werden jetzt auch unter Linux gelscht.
- Verbesserung Zentrieren+Skalieren fr den Fall xmin=xmax und ymin=ymax.
- Extension verbessert beim Speichern unter Linux.

Neue Funktionen / Methoden:
    clear_context_menu


Version 0.1.0_beta01 vom 22.01.2005
~~~~~~~~~~~~~~~~~~~~
>  20.497 Byte -    606 Zeilen - Graph::GED::Animation.pm
>  12.071 Byte -    308 Zeilen -     Graph::GED::Basis.pm
>   6.845 Byte -    202 Zeilen -      Graph::GED::Core.pm
>  10.028 Byte -    268 Zeilen -      Graph::GED::Data.pm
>   7.916 Byte -    218 Zeilen -      Graph::GED::Ecke.pm
>   6.362 Byte -    185 Zeilen -     Graph::GED::FHist.pm
>   9.769 Byte -    309 Zeilen -      Graph::GED::Geom.pm
>  28.404 Byte -    794 Zeilen -     Graph::GED::Graph.pm
> 114.909 Byte -  2.828 Zeilen -   Graph::GED::Graph2D.pm
> 215.932 Byte -  5.052 Zeilen -       Graph::GED::Gui.pm
>  40.425 Byte -  1.000 Zeilen -  Graph::GED::Historie.pm
>   9.641 Byte -    260 Zeilen -     Graph::GED::Kante.pm
>  12.127 Byte -    326 Zeilen -     Graph::GED::Logic.pm
>  11.456 Byte -    286 Zeilen -      Graph::GED::Test.pm
>  59.542 Byte -  1.604 Zeilen -      Graph::GED::Text.pm
>  12.212 Byte -    294 Zeilen -   Graph::GED::TkTools.pm
>   1.847 Byte -     75 Zeilen -                   ged.pl
> -------        ------
> 579.983 Byte - 14.615 Zeilen

- devtools-Verzeichnis angelegt, Modul DevTools.pm und programm mkversion.pl
  erstellt.
- POD in Graph.pm: Methodenbeschreibung eingefgt.
- POD in Graph2D.pm: Fehlende =back's ergnzt.
- POD in Basis.pm: Methodenbeschreibung eingefgt.
- POD in TkTools.pm: Methodenbeschreibung eingefgt.
- Graph::GED::Animation angelegt (in Graph/GED/Animation.pm). Als erster
  Schritt auf dem Weg zur Internationalisierung ist dieses Modul in englischer
  Sprache dokumentiert.
- Graph::GED::Gui erstellt und Tk-Funktionen aus ged.pl dorthin ausgelagert.
- Graph::GED::Logic erstellt und logische Funktionen aus ged.pl dorthin
  ausgelagert.
- Graph::GED::Data erstellt und Funktionen zum Daten-Handling aus ged.pl
  dorthin ausgelagert.
- Graph::GED::Text erstellt und Todo- und Historytexte dorthin ausgelagert.
- Graph::GED::Test erstellt und Test-Funktionen aus ged.pl dorthin ausgelagert.
- Liniengraphenerstellung verbessert: Daten des Graphen werden vorher
  gespeichert und hinterher wieder hergestellt (Farben, Gittereinstellungen,
  Hintergrundbild, ...).
- Globale Daten nach Graph::GED::Core verschoben.
- Diverse POD-Verbesserungen und Ergnzungen.
- Neue Meneintrge fr die Perldoc-Anzeige der neuen Module.
- Kernfunktionalitten von load_ged3 nach load_ged3_from_string ausgelagert.
- Kernfunktionalitten von save_ged3 nach save_ged3_to_handle ausgelagert.
- Animationen erstellen, speichen und laden.
- Animationsverwaltung

Bekannte Probleme:
    - changed-Anzeige funktioniert noch nicht wieder richtig, da noch auf
      Graphenebene
    - Gelegentliche Probleme mit verschwindenden Graphen in der Animation im
      Zusammenhang mit Zurcknehmen.
    - Animationsverwaltung ist bisher noch ohne Funktion, hier soll man spter
      die Animationselemente verschieben, duplizieren und lschen knnen.

Neue Funktionen / Methoden:
    Graph::GED::Animation::_graphs
    Graph::GED::Animation::set_graphs
    Graph::GED::Animation::delete_graphs
    Graph::GED::Animation::graph
    Graph::GED::Animation::delete_graph_index
    Graph::GED::Animation::insert_graph_index
    Graph::GED::Animation::push_graph
    Graph::GED::Animation::pop_graph
    Graph::GED::Animation::_histories
    Graph::GED::Animation::set_histories
    Graph::GED::Animation::delete_histories
    Graph::GED::Animation::history
    Graph::GED::Animation::delete_history_index
    Graph::GED::Animation::insert_history_index
    Graph::GED::Animation::push_history
    Graph::GED::Animation::pop_history
    Graph::GED::Animation::clear
    Graph::GED::Animation::number_of_graphs
    Graph::GED::Animation::number_of_histories
    Graph::GED::Gui::tk_start
    Graph::GED::Gui::add_file_menu
    Graph::GED::Gui::bind_start
    Graph::GED::Gui::zeichnen_anfang
    Graph::GED::Gui::aendere_item
    Graph::GED::Gui::zeichnen_ende
    Graph::GED::Gui::refresh
    Graph::GED::Gui::clear
    Graph::GED::Gui::zeichne_ecke
    Graph::GED::Gui::zeichne_kante
    Graph::GED::Gui::lade_datei
    Graph::GED::Gui::speichere_datei
    Graph::GED::Gui::speichere_datei_als
    Graph::GED::Gui::export_nach_latex
    Graph::GED::Gui::export_nach_postscript
    Graph::GED::Gui::dump_eingeben
    Graph::GED::Gui::zeige_daten_an
    Graph::GED::Gui::zeige_daten_an_dumper
    Graph::GED::Gui::hilfe
    Graph::GED::Gui::graph_erkl
    Graph::GED::Gui::history
    Graph::GED::Gui::todo
    Graph::GED::Gui::show_perldoc
    Graph::GED::Gui::ueber_ged
    Graph::GED::Gui::canvas_groesse
    Graph::GED::Gui::waehle_eckenfarbe
    Graph::GED::Gui::waehle_kantenfarbe
    Graph::GED::Gui::historie_schalter_aktualisieren
    Graph::GED::Gui::context_menu
    Graph::GED::Gui::tk_cm_groessenwahl
    Graph::GED::Gui::tk_cm_kantenformwahl
    Graph::GED::Gui::tk_cm_kantenstilwahl
    Graph::GED::Gui::tk_cm_kantendicke
    Graph::GED::Gui::tk_cm_titelwahl
    Graph::GED::Gui::tk_cm_titelausrichtung
    Graph::GED::Gui::tk_cm_wertwahl
    Graph::GED::Gui::tk_cm_wertausrichtung
    Graph::GED::Gui::tk_beenden
    Graph::GED::Gui::clear_context_menu
    Graph::GED::Test::geom_test
    Graph::GED::Test::clone_test
    Graph::GED::Test::historie_test
    Graph::GED::Logic::beenden
    Graph::GED::Logic::struktur_einfuegen
    Graph::GED::Logic::raste_ein
    Graph::GED::Logic::erzeuge_liniengraphen
    Graph::GED::Logic::rueckgaengig
    Graph::GED::Logic::wiederholung
    Graph::GED::Logic::aenderung
    Graph::GED::Data::dump_data
    Graph::GED::Data::save
    Graph::GED::Data::load
    Graph::GED::Data::neue_datei
    Graph::GED::Data::add
    Graph::GED::Gui::start
    Graph::GED::Core::start
    Graph::GED::Graph2D::load_ged3_from_string
    Graph::GED::Graph2D::save_ged3_to_handle
    Graph::GED::Animation::save
    Graph::GED::Animation::load
    Graph::GED::Gui::lade_animation
    Graph::GED::Gui::speichere_animation
    Graph::GED::Gui::speichere_animation_als
    Graph::GED::Animation::filename
    Graph::GED::Gui::set_title

Entfernte Funktionen / Methoden:
    tk_start
    add_file_menu
    bind_start
    zeichnen_anfang
    aendere_item
    zeichnen_ende
    refresh
    clear
    zeichne_ecke
    zeichne_kante
    lade_datei
    speichere_datei
    speichere_datei_als
    export_nach_latex
    export_nach_postscript
    dump_eingeben
    zeige_daten_an
    zeige_daten_an_dumper
    hilfe
    graph_erkl
    history
    todo
    perldoc_ged_pl
    perldoc_graph_ged_basis_pm
    perldoc_graph_ged_ecke_pm
    perldoc_graph_ged_kante_pm
    perldoc_graph_ged_graph_pm
    perldoc_graph_ged_graph2d_pm
    perldoc_graph_ged_geom_pm
    perldoc_graph_ged_historie_pm
    perldoc_graph_ged_fhist_pm
    perldoc_graph_ged_tktools_pm
    ueber_ged
    canvas_groesse
    waehle_eckenfarbe
    waehle_kantenfarbe
    historie_schalter_aktualisieren
    context_menu
    tk_cm_groessenwahl
    tk_cm_kantenformwahl
    tk_cm_kantenstilwahl
    tk_cm_kantendicke
    tk_cm_titelwahl
    tk_cm_titelausrichtung
    tk_cm_wertwahl
    tk_cm_wertausrichtung
    tk_beenden
    clear_context_menu
    do_all_the_tests
    clone_test
    historie_test
    beenden
    struktur_einfuegen
    raste_ein
    erzeuge_liniengraphen
    rueckgaengig
    wiederholung
    aenderung
    dump_data
    save
    load
    neue_datei
    add
HISTORYTEXT



1;


__END__

=head1 NAME

Graph::GED::Text.pm - a package with the texts of todo list and history of GED

=head1 Variables

=over

=item C<$Todotext>

    Todo list.

=item C<$Historytext>

    History list.

=back

=head1 COPYRIGHT

Copyright 2005 Christian Duehl. All rights reserved.

This library is free software. You can redistribute it and/or
modify it under the same terms as perl itself.

=cut
